using System;
using Syntriax.Modules.State;

namespace Syntriax.Modules.Action
{
    public class ActionWithDeactivation : Action, IActionWithDeactivation
    {
        public Action<IAction> OnDeactivated { get; set; } = null;

        public void Deactivate()
        {
            if (!StateEnable.IsEnabledNullChecked())
                return;

            OnDeactivated?.Invoke(this);
        }
    }
}
