using System;

namespace Syntriax.Modules.Action
{
    public interface IActionWithDeactivation : IAction
    {
        /// <summary>
        /// Called when the <see cref="IAction"/> is Deactivated
        /// </summary>
        /// <value>The <see cref="IAction"/> that Deactivated</value>
        Action<IAction> OnDeactivated { get; set; }

        /// <summary>
        /// Called when the <see cref="IAction"/> is Deactivated
        /// </summary>
        void Deactivate();
    }
}
